--- axes.py	2006-03-20 11:28:21.000000000 -0700
+++ axes.py.orig	2006-03-20 10:55:54.000000000 -0700
@@ -3964,15 +3964,6 @@
                           keep it centered.
              'box_size' - as above, but anchored to lower left
              'datalim'  - change xlim or ylim
-             'center'   - same as 'position'
-             'bottom_left' - same as 'box_size'
-             'bottom_right' - anchor to lower right
-             'upper_left' - anchor to upper left
-             'upper_right' - anchor to upper right
-             'center_right' - anchor to right, but center in vertical
-             'center_left' - anchor to left, but center in vertical
-             'center_bottom' - anchor to bottom, center in horizontal
-             'center_top' - anchor to top, center in horizontal
 
         fixLimits: deprecated; False is aspect_adjusts='datalim';
                    True is aspect_adjusts='position'
@@ -3988,38 +3979,23 @@
 
         if fixLimits is not None:
             if not fixLimits: aspect_adjusts = 'datalim'
-        if aspect_adjusts in ('position', 'box_size',\
-           'upper_left','bottom_left','center_left','upper_right',\
-           'bottom_right','center_right','center','center_bottom',\
-           'center_top'):
+        if aspect_adjusts in ('position', 'box_size', 'datalim'):
             self._aspect_adjusts = aspect_adjusts
         else:
-            raise ValueError("""
-aspect_adjusts must be 'position', 'box_size', 'datalim'
-'upper_left','bottom_left','center_left','upper_right',
-'bottom_right','center_right','center','center_bottom' or 'center_top,
-got %s""" % aspect_adjusts)
+            raise ValueError(
+                'aspect_adjusts must be "position", "box_size", or "datalim"')
 
     def set_aspect_adjusts(self, aspect_adjusts = 'position'):
         """
         Must be called after set_aspect.
 
-        ACCEPTS: ['position' | 'box_size' | 'datalim' | 'upper_left'
-                  'upper_right' | 'bottom_left' | 'bottom_right'
-                  'center_left' | 'center_right' | 'center'
-                  'center_bottom' | 'center_top' ]
-        """
-        if aspect_adjusts in ('position', 'box_size',\
-           'upper_left','bottom_left','center_left','upper_right',\
-           'bottom_right','center_right','center','center_bottom',\
-           'center_top'):
+        ACCEPTS: ['position' | 'box_size' | 'datalim']
+        """
+        if aspect_adjusts in ('position', 'box_size', 'datalim'):
             self._aspect_adjusts = aspect_adjusts
         else:
-            raise ValueError("""
-aspect_adjusts must be 'position', 'box_size', 'datalim'
-'upper_left','bottom_left','center_left','upper_right',
-'bottom_right','center_right','center','center_bottom' or 'center_top,
-got %s""" % aspect_adjusts)
+            raise ValueError(
+                'argument must be "position", "box_size", or "datalim"')
 
 
     def apply_aspect(self):
@@ -4044,10 +4020,7 @@
         ymin,ymax = self.get_ylim()
         ysize = math.fabs(ymax-ymin)
         l,b,w,h = self._originalPosition
-        if self._aspect_adjusts in ('position', 'box_size',\
-           'upper_left','bottom_left','center_left','upper_right',\
-           'bottom_right','center_right','center','center_bottom',\
-           'center_top'):
+        if self._aspect_adjusts in ('position', 'box_size'):
             data_ratio = ysize/xsize
             box_aspect = A * data_ratio
             H = w * box_aspect/fig_aspect
@@ -4056,34 +4029,11 @@
             else:
                 W = h * fig_aspect/box_aspect
                 H = h
-            if self._aspect_adjusts in ('center','position'):
+            if self._aspect_adjusts == 'position':
                 L = l + 0.5 * (w-W)
                 B = b + 0.5 * (h-H)
-            elif self._aspect_adjusts in ('box_size','bottom_left'):
+            else:
                 L,B = l,b
-            elif self._aspect_adjusts == 'center_left':
-                L = l
-                B = b + 0.5 * (h-H)
-            elif self._aspect_adjusts == 'upper_left':
-                L = l
-                B = b + h
-            elif self._aspect_adjusts == 'center_bottom':
-                L = l + 0.5 * (w-W)
-                B = b
-            elif self._aspect_adjusts == 'upper_right':
-                L = l + w
-                B = b + h
-            elif self._aspect_adjusts == 'center_right':
-                L = l + w
-                B = b + 0.5 * (h-H)
-            elif self._aspect_adjusts == 'bottom_right':
-                L = l + w
-                b = b
-            elif self._aspect_adjusts == 'center_top':
-                L = l + 0.5 * (w-W)
-                B = b + h
-
-                
             self.set_position((L,B,W,H))
             return
 